/******************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEF
Avj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ
܂Bɂ́A\tgEFA̕gpAʁAύXAAfځAЕzATu
CZXA/܂͔̔錠Aу\tgEFA񋟂鑊ɓ
Ƃ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
Lڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KAьN
QɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B ҂܂͒
쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tgEFAɋN܂
֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
*******************************************************************************/
#include  "wgl_font.h"


//==============
//  tHg
//==============

//-- rp̕
const char*
make_ruby_string(const char *p1, char* p2, int str_max)
{
	int i=0;
	while (true) {
		char  ch1, ch2;
		ch1 = *p1;
		ch2 = *(p1+1);

		if (isMB(ch1, ch2)) {
			// }`oCg
			if (i+2 >= str_max)  { *p2='\0'; return NULL; }
			*p2++ = ch1;
			*p2++ = ch2;
			p1 += 2;
			i  += 2;
		} else {
			// VOoCg
			if (ch1=='}')  {
				*p2='\0';
				return p1+1;
			}
			if (ch1=='\0' || i+1>str_max)  {
				*p2='\0';
				return NULL;
			}
			*p2++ = ch1;
			p1++;
			i++;
		}
	}
}


//-- `
void
wgl_font::draw_text(const char* str, float D)
{
	const int str_max = 512;
	float w0, h0, dw, dh;
	char ruby[str_max+1];


	w0 = 0;
	h0 = 0;
	const char* p = str;
	while(*p != '\0') {
		dw = dh = 0.0;

		char  ch1, ch2;
		ch1 = *p++;
		ch2 = *p;

		if (isMB(ch1, ch2)) {
			// }`oCg̕\
			draw_char_MB(ch1, ch2);
			get_glyph_size_MB(ch1, ch2, dw, dh);
			p++;
		} else {
			switch (ch1) {
				case '{':
					w0=0;
					continue;
				case '|':
					{
						const char* p2;
						p2 = make_ruby_string(p, ruby, str_max);
						if (bRuby) {
							// r\
							glPushMatrix();
								glTranslatef(-w0,h0,0);
								glScalef(ruby_sz,ruby_sz,1);
								draw_per_capita_basis(w0/ruby_sz, ruby);
							glPopMatrix();
						}
						if (p2==NULL)  return;
						p = p2;
					}
					continue;
				case '\\':			// ꕶ
					draw_special_char(p);
					p++;
					break;
				case '^':			// t
					draw_superscript(p);
					p++;
					break;
				case '_':			// t
					draw_subscript(p);
					p++;
					break;
				default:			// ʏ̂PoCg̕\
					draw_char_SB(ch1);
					get_glyph_size_SB(ch1, dw, dh);
					break;
			}
		}
		glTranslatef(D,0,0);	// iϓȂǂŎgpj
		w0 += dw + D;			// ̕XV
		h0 = max(h0, dh);
	}
}


//-- t`
void
wgl_font::draw_textf(const char* szFormat, ...)
{
	static char		szBuffer[1024];
	va_list			pArgs;
	va_start( pArgs, szFormat );
	vsprintf( szBuffer, szFormat, pArgs );
	va_end( pArgs );
	draw_text(szBuffer);
}

//-- ̃TCY擾
int
wgl_font::get_text_size(const char* str, float& w, float& h)
{
	int n=0;
	const char* p = str;
	w = h = 0;
	
	while (*p != '\0') {
		float dw, dh;
		char  ch1, ch2;
		ch1 = *p++;
		ch2 = *p;
		if (isMB(ch1, ch2)) {
				fnt_MB.get_glyph_size(get_MB_code(ch1, ch2), dw, dh);
				p++;
		} else {
			if (ch1=='{') { continue; }
			if (ch1=='|') {
				// r̓̕XLbv
				ch1 = ch2;
				while (ch1!='}') {
					p++;
					ch1 = *p;
					if (ch1=='\0')  break;
				};
				p++;
				continue;
			}
			fnt_SB.get_glyph_size(ch1, dw, dh);
		}
		w += dw;
		if (h < dh)  h = dh;
		n++;
	}
	return n;
}


//-- t
void
wgl_font::draw_superscript(const char* p)
{
	const float& sz = superscript_sz;
	char ch2;
	float dw, dh;

	ch2 = *p;
	fnt_SB.get_glyph_size2(ch2, dw,dh);
	glPushMatrix();
		glTranslatef(0,dh*(1.0f-sz),0);
		glScalef(sz,sz,sz);
		fnt_SB.draw_char(ch2);
	glPopMatrix();
	glTranslatef(sz*dw, 0,0);
}

//-- t
void
wgl_font::draw_subscript(const char* p)
{
	const float& sz = subscript_sz;
	char ch2;
	float dw, dh;

	ch2 = *p;
	fnt_SB.get_glyph_size2(ch2, dw,dh);
	glPushMatrix();
		glScalef(sz,sz,sz);
		fnt_SB.draw_char(ch2);
	glPopMatrix();
	glTranslatef(sz*dw, 0,0);
}


//-----------
//  ꕶ
//-----------

// Copyright }[N
void
wgl_font::draw_Copyright()
{
	draw_text("");
	glPushMatrix();
		glTranslatef(-0.72,0.15,0);
		fnt_SB.draw_char('c');
	glPopMatrix();
}


//-- ꕶ
void
wgl_font::draw_special_char(const char* p)
{
	char ch2, ch3;
	float dw, dh;

	ch2 = *p;
	ch3 = *(p+1);
	switch (ch2) {
		case 'C':
		case 'c':	// Copyright }[N
			draw_Copyright();
			break;
		case '\"':
			fnt_SB.get_glyph_size2(ch3, dw,dh);
			glPushMatrix();
				glTranslatef(0,dh+0.1,0);
				draw_per_capita_basis(dw, "..");
			glPopMatrix();
			break;
		case '\'':
			fnt_SB.get_glyph_size2(ch3, dw,dh);
			glPushMatrix();
				glTranslatef(0,dh-0.3,0);
				draw_per_capita_basis(dw, "\'");
			glPopMatrix();
			break;
		default:
			break;
	}
}

//-- 
void
wgl_font::prepare_centering(const char* str)
{
	float w, h;
	get_text_size(str, w, h);
	glTranslatef(-0.5f*w,-0.5f*h,0);
}

//-- E
void
wgl_font::prepare_flushright(const char* str)
{
	float w, h;
	get_text_size(str, w, h);
	glTranslatef(-w,0,0);
}

//-- ϓ
void
wgl_font::draw_per_capita_basis(float w0, const char* str)
{
	int N;
	float w, h, D;

	N = get_text_size(str, w, h);
	if (N<=0)  return;
	if (N==1) {
		// P̎͒ɕ\
		D = (w0-w)/2.0;
		glTranslatef(D,0,0);
	} else {
		// Qȏ̎
		D = (w0-w)/(N-1);
	}

	draw_text(str, D);
}
